--- old/usr/src/uts/common/io/scsi/targets/sd.c	Mon Aug  5 17:31:49 2019
+++ new/usr/src/uts/common/io/scsi/targets/sd.c	Mon Aug  5 17:31:49 2019
@@ -12478,6 +12180,8 @@
 
 	un->un_ncmds_in_driver--;
 	ASSERT(un->un_ncmds_in_driver >= 0);
+	if (un->un_f_detach_waiting)
+		cv_signal(&un->un_detach_cv);
 	SD_INFO(SD_LOG_IO, un, "sd_uscsi_iodone: un_ncmds_in_driver = %ld\n",
 	    un->un_ncmds_in_driver);
 
@@ -12875,10 +12579,8 @@
 		goto done;
 	}
 
-#if defined(__i386) || defined(__amd64)
 	/* We do not support non-block-aligned transfers for ROD devices */
 	ASSERT(!ISROD(un));
-#endif
 
 	xp = SD_GET_XBUF(bp);
 	ASSERT(xp != NULL);
@@ -13577,12 +13279,10 @@
 	 * performance using CDB_GROUP0 commands (where applicable).
 	 */
 	un->un_mincdb = SD_CDB_GROUP1;
-#if !defined(__fibre)
 	if (!un->un_f_is_fibre && !un->un_f_cfg_is_atapi && !ISROD(un) &&
 	    !un->un_f_has_removable_media) {
 		un->un_mincdb = SD_CDB_GROUP0;
 	}
-#endif
 
 	/*
 	 * Try to read the max-cdb-length supported by HBA.
@@ -13620,7 +13320,7 @@
 	un->un_status_len = (int)((un->un_f_arq_enabled == TRUE)
 	    ? sizeof (struct scsi_arq_status) : 1);
 	if (!ISCD(un))
-		un->un_cmd_timeout = (ushort_t)sd_io_time;
+		un->un_cmd_timeout = (ushort_t)un->un_io_time;
 	un->un_uscsi_timeout = ((ISCD(un)) ? 2 : 1) * un->un_cmd_timeout;
 }
 
@@ -13672,7 +13372,6 @@
 
 	mutex_exit(SD_MUTEX(un));
 
-#if defined(__i386) || defined(__amd64)	/* DMAFREE for x86 only */
 	if (xp->xb_pkt_flags & SD_XB_DMA_FREED) {
 		/*
 		 * Already have a scsi_pkt -- just need DMA resources.
@@ -13688,7 +13387,6 @@
 	} else {
 		pktp = NULL;
 	}
-#endif /* __i386 || __amd64 */
 
 	startblock = xp->xb_blkno;	/* Absolute block num. */
 	blockcount = SD_BYTES2TGTBLOCKS(un, bp->b_bcount);
@@ -13736,9 +13434,7 @@
 		SD_TRACE(SD_LOG_IO_CORE, un,
 		    "sd_initpkt_for_buf: exit: buf:0x%p\n", bp);
 
-#if defined(__i386) || defined(__amd64)	/* DMAFREE for x86 only */
 		xp->xb_pkt_flags &= ~SD_XB_DMA_FREED;
-#endif
 
 		mutex_enter(SD_MUTEX(un));
 		return (SD_PKT_ALLOC_SUCCESS);
@@ -14402,16 +14098,11 @@
 	}
 
 	bflags &= (B_READ | B_WRITE);
-#if defined(__i386) || defined(__amd64)
 	new_bp = getrbuf(KM_SLEEP);
 	new_bp->b_un.b_addr = kmem_zalloc(datalen, KM_SLEEP);
 	new_bp->b_bcount = datalen;
 	new_bp->b_flags = bflags |
 	    (bp->b_flags & ~(B_PAGEIO | B_PHYS | B_REMAPPED | B_SHADOW));
-#else
-	new_bp = scsi_alloc_consistent_buf(SD_ADDRESS(un), NULL,
-	    datalen, bflags, SLEEP_FUNC, NULL);
-#endif
 	new_bp->av_forw	= NULL;
 	new_bp->av_back	= NULL;
 	new_bp->b_dev	= bp->b_dev;
@@ -14500,16 +14191,7 @@
 	xp = SD_GET_XBUF(bp);
 	ASSERT(xp != NULL);
 
-#if defined(__sparc)
 	/*
-	 * Call bp_mapout() before freeing the buf,  in case a lower
-	 * layer or HBA  had done a bp_mapin().  we must do this here
-	 * as we are the "originator" of the shadow buf.
-	 */
-	bp_mapout(bp);
-#endif
-
-	/*
 	 * Null out b_iodone before freeing the bp, to ensure that the driver
 	 * never gets confused by a stale value in this field. (Just a little
 	 * extra defensiveness here.)
@@ -14516,12 +14198,8 @@
 	 */
 	bp->b_iodone = NULL;
 
-#if defined(__i386) || defined(__amd64)
 	kmem_free(bp->b_un.b_addr, bp->b_bcount);
 	freerbuf(bp);
-#else
-	scsi_free_consistent_buf(bp);
-#endif
 
 	kmem_free(xp, sizeof (struct sd_xbuf));
 }
@@ -14747,9 +14425,7 @@
 	struct	sd_xbuf	*xp;
 	struct	buf	*bp;
 	void	(*statp)(kstat_io_t *);
-#if defined(__i386) || defined(__amd64)	/* DMAFREE for x86 only */
 	void	(*saved_statp)(kstat_io_t *);
-#endif
 	int	rval;
 	struct sd_fm_internal *sfip = NULL;
 
@@ -14760,10 +14436,26 @@
 
 	SD_TRACE(SD_LOG_IO_CORE | SD_LOG_ERROR, un, "sd_start_cmds: entry\n");
 
+	/*
+	 * If device is currently retired, we should abort all pending I/O.
+	 */
+	if (DEVI(un->un_sd->sd_dev)->devi_flags & DEVI_RETIRED) {
+		if (immed_bp) {
+			immed_bp->b_resid = immed_bp->b_bcount;
+			bioerror(immed_bp, ENXIO);
+			biodone(immed_bp);
+		}
+		/* abort in-flight IO */
+		(void) scsi_abort(SD_ADDRESS(un), NULL);
+		/* abort pending IO */
+		un->un_failfast_state = SD_FAILFAST_ACTIVE;
+		un->un_failfast_bp = NULL;
+		sd_failfast_flushq(un, B_TRUE);
+		return;
+	}
+
 	do {
-#if defined(__i386) || defined(__amd64)	/* DMAFREE for x86 only */
 		saved_statp = NULL;
-#endif
 
 		/*
 		 * If we are syncing or dumping, fail the command to
@@ -14820,9 +14512,7 @@
 				    kstat_runq_back_to_waitq)) {
 					statp = kstat_waitq_to_runq;
 				}
-#if defined(__i386) || defined(__amd64)	/* DMAFREE for x86 only */
 				saved_statp = un->un_retry_statp;
-#endif
 				un->un_retry_statp = NULL;
 
 				SD_TRACE(SD_LOG_IO | SD_LOG_ERROR, un,
@@ -14899,9 +14589,13 @@
 		 * not be put back to normal. Doing so would would
 		 * allow new commands to proceed when they shouldn't,
 		 * the device may be going off.
+		 *
+		 * Similarly, if the state is SD_STATE_ATTACHING we should
+		 * not set it to SD_STATE_NORMAL to avoid corruption.
 		 */
 		if ((un->un_state != SD_STATE_SUSPENDED) &&
-		    (un->un_state != SD_STATE_PM_CHANGING)) {
+		    (un->un_state != SD_STATE_PM_CHANGING) &&
+		    (un->un_state != SD_STATE_ATTACHING)) {
 			New_state(un, SD_STATE_NORMAL);
 		}
 
@@ -14908,7 +14602,6 @@
 		xp = SD_GET_XBUF(bp);
 		ASSERT(xp != NULL);
 
-#if defined(__i386) || defined(__amd64)	/* DMAFREE for x86 only */
 		/*
 		 * Allocate the scsi_pkt if we need one, or attach DMA
 		 * resources if we have a scsi_pkt that needs them. The
@@ -14917,9 +14610,6 @@
 		 */
 		if ((xp->xb_pktp == NULL) ||
 		    ((xp->xb_pkt_flags & SD_XB_DMA_FREED) != 0)) {
-#else
-		if (xp->xb_pktp == NULL) {
-#endif
 			/*
 			 * There is no scsi_pkt allocated for this buf. Call
 			 * the initpkt function to allocate & init one.
@@ -14987,8 +14677,6 @@
 				SD_TRACE(SD_LOG_IO_CORE | SD_LOG_ERROR, un,
 				    "sd_start_cmds: SD_PKT_ALLOC_FAILURE\n");
 
-#if defined(__i386) || defined(__amd64)	/* DMAFREE for x86 only */
-
 				if (bp == immed_bp) {
 					/*
 					 * If SD_XB_DMA_FREED is clear, then
@@ -15060,12 +14748,6 @@
 					goto exit;
 				}
 
-#else
-				if (bp == immed_bp) {
-					break;	/* Just fail the command */
-				}
-#endif
-
 				/* Add the buf back to the head of the waitq */
 				bp->av_forw = un->un_waitq_headp;
 				un->un_waitq_headp = bp;
@@ -15086,9 +14768,9 @@
 
 			case SD_PKT_ALLOC_FAILURE_PKT_TOO_SMALL:
 				/*
-				 * Note:x86: Partial DMA mapping not supported
-				 * for USCSI commands, and all the needed DMA
-				 * resources were not allocated.
+				 * Partial DMA mapping not supported for USCSI
+				 * commands, and all the needed DMA resources
+				 * were not allocated.
 				 */
 				SD_TRACE(SD_LOG_IO_CORE | SD_LOG_ERROR, un,
 				    "sd_start_cmds: "
@@ -15097,8 +14779,8 @@
 
 			case SD_PKT_ALLOC_FAILURE_CDB_TOO_SMALL:
 				/*
-				 * Note:x86: Request cannot fit into CDB based
-				 * on lba and len.
+				 * Request cannot fit into CDB based on lba
+				 * and len.
 				 */
 				SD_TRACE(SD_LOG_IO_CORE | SD_LOG_ERROR, un,
 				    "sd_start_cmds: "
@@ -15137,6 +14819,9 @@
 
 		un->un_ncmds_in_transport++;
 		SD_UPDATE_KSTATS(un, statp, bp);
+		/* The start time MAY be overriden by the HBA driver. */
+		xp->xb_pktp->pkt_start = gethrtime();
+		xp->xb_pktp->pkt_stop = 0;
 
 		/*
 		 * Call scsi_transport() to send the command to the target.
@@ -15150,6 +14835,14 @@
 		    "sd_start_cmds: calling scsi_transport()\n");
 		DTRACE_PROBE1(scsi__transport__dispatch, struct buf *, bp);
 
+#ifdef SD_FAULT_INJECTION
+		/*
+		 * Packet is ready for submission to the HBA. Perform HBA-based
+		 * fault-injection.
+		 */
+		sd_prefaultinjection(xp->xb_pktp);
+#endif /* SD_FAULT_INJECTION */
+
 		mutex_exit(SD_MUTEX(un));
 		rval = scsi_transport(xp->xb_pktp);
 		mutex_enter(SD_MUTEX(un));
@@ -15167,13 +14860,36 @@
 			un->un_ncmds_in_transport--;
 			ASSERT(un->un_ncmds_in_transport >= 0);
 
+#ifdef SD_FAULT_INJECTION
 			/*
+			 * If the packet was rejected during active fault
+			 * injection session, move to the next fault slot
+			 * and reset packet flag related to rejection.
+			 */
+			if (sd_fault_injection_on) {
+				uint_t i = un->sd_fi_fifo_start;
+
+				if (un->sd_fi_fifo_tran[i] != NULL) {
+					kmem_free(un->sd_fi_fifo_tran[i],
+					    sizeof (struct sd_fi_tran));
+					un->sd_fi_fifo_tran[i] = NULL;
+				}
+				un->sd_fi_fifo_start++;
+			}
+
+			if (xp->xb_pktp->pkt_flags & FLAG_PKT_BUSY) {
+				xp->xb_pktp->pkt_flags &= ~FLAG_PKT_BUSY;
+			}
+#endif /* SD_FAULT_INJECTION */
+
+			/*
 			 * Don't retry request sense, the sense data
 			 * is lost when another request is sent.
 			 * Free up the rqs buf and retry
 			 * the original failed cmd.  Update kstat.
 			 */
-			if (bp == un->un_rqs_bp) {
+			if ((un->un_ncmds_in_transport > 0) &&
+			    (bp == un->un_rqs_bp)) {
 				SD_UPDATE_KSTATS(un, kstat_runq_exit, bp);
 				bp = sd_mark_rqs_idle(un, xp);
 				sd_retry_command(un, bp, SD_RETRIES_STANDARD,
@@ -15182,7 +14898,6 @@
 				goto exit;
 			}
 
-#if defined(__i386) || defined(__amd64)	/* DMAFREE for x86 only */
 			/*
 			 * Free the DMA resources for the  scsi_pkt. This will
 			 * allow mpxio to select another path the next time
@@ -15195,7 +14910,6 @@
 				scsi_dmafree(xp->xb_pktp);
 				xp->xb_pkt_flags |= SD_XB_DMA_FREED;
 			}
-#endif
 
 			if (SD_IS_DIRECT_PRIORITY(SD_GET_XBUF(bp))) {
 				/*
@@ -15242,7 +14956,7 @@
 
 			/*
 			 * Set up the bp to be tried again 10 ms later.
-			 * Note:x86: Is there a timeout value in the sd_lun
+			 * XXX Is there a timeout value in the sd_lun
 			 * for this condition?
 			 */
 			sd_set_retry_bp(un, bp, un->un_busy_timeout / 500,
@@ -15371,7 +15085,7 @@
 			sd_retry_command(un, bp, SD_RETRIES_NOCHECK,
 			    NULL, NULL, 0, (clock_t)0, NULL);
 			sd_start_cmds(un, NULL);
-			return;	/* Note:x86: need a return here? */
+			return;	/* XXX need a return here? */
 		}
 	}
 
@@ -15587,6 +15301,12 @@
  *		   in the pkt. If FLAG_ISOLATE is set, then the command is
  *		   not retried, it is simply failed.
  *
+ *		   Optionally may be bitwise-OR'ed with SD_RETRIES_FAILFAST
+ *		   to indicate a retry following a command timeout, and check
+ *		   if the target should transition to failfast pending or
+ *		   failfast active. If the buf has B_FAILFAST set, the
+ *		   command should be failed when failfast is active.
+ *
  *		user_funcp - Ptr to function to call before dispatching the
  *		   command. May be NULL if no action needs to be performed.
  *		   (Primarily intended for printing messages.)
@@ -15691,6 +15411,23 @@
 		}
 	}
 
+	if (sd_failfast_enable & (SD_FAILFAST_ENABLE_FAIL_RETRIES |
+	    SD_FAILFAST_ENABLE_FAIL_ALL_RETRIES)) {
+		if (sd_failfast_enable & SD_FAILFAST_ENABLE_FAIL_ALL_RETRIES) {
+			/*
+			 * Fail ALL retries when in active failfast state,
+			 * regardless of reason.
+			 */
+			if (un->un_failfast_state == SD_FAILFAST_ACTIVE) {
+				goto fail_command;
+			}
+		}
+		/*
+		 * Treat bufs being retried as if they have the
+		 * B_FAILFAST flag set.
+		 */
+		bp->b_flags |= B_FAILFAST;
+	}
 
 	/*
 	 * If SD_RETRIES_FAILFAST is set, it indicates that either a
@@ -15742,7 +15479,7 @@
 				 */
 				un->un_failfast_state = SD_FAILFAST_ACTIVE;
 				un->un_failfast_bp = NULL;
-				sd_failfast_flushq(un);
+				sd_failfast_flushq(un, B_FALSE);
 
 				/*
 				 * Fail this bp now if B_FAILFAST set;
@@ -15783,8 +15520,14 @@
 		 * In this case we want to be aggressive about clearing
 		 * the failfast state. Note that this does not affect
 		 * the "failfast pending" condition.
+		 *
+		 * We limit this to retries that are not a side effect of an
+		 * unrelated event, as it would be unwise to clear failfast
+		 * active state when we see retries due to a reset.
 		 */
-		un->un_failfast_state = SD_FAILFAST_INACTIVE;
+		if ((sd_failfast_enable & SD_FAILFAST_ENABLE_FORCE_INACTIVE) &&
+		    (retry_check_flag & SD_RETRIES_MASK) != SD_RETRIES_VICTIM)
+			un->un_failfast_state = SD_FAILFAST_INACTIVE;
 	}
 
 
@@ -16225,9 +15968,8 @@
  *     Context: May be called from interrupt context.
  */
 
-static void
-sd_send_request_sense_command(struct sd_lun *un, struct buf *bp,
-    struct scsi_pkt *pktp)
+static void sd_send_request_sense_command(struct sd_lun *un, struct buf *bp,
+    int retry_check_flag, struct scsi_pkt *pktp)
 {
 	ASSERT(bp != NULL);
 	ASSERT(un != NULL);
@@ -16254,14 +15996,11 @@
 	 *    1) the sense buf is busy
 	 *    2) we have 1 or more outstanding commands on the target
 	 *    (the sense data will be cleared or invalidated any way)
-	 *
-	 * Note: There could be an issue with not checking a retry limit here,
-	 * the problem is determining which retry limit to check.
 	 */
 	if ((un->un_sense_isbusy != 0) || (un->un_ncmds_in_transport > 0)) {
 		/* Don't retry if the command is flagged as non-retryable */
 		if ((pktp->pkt_flags & FLAG_DIAGNOSE) == 0) {
-			sd_retry_command(un, bp, SD_RETRIES_NOCHECK,
+			sd_retry_command(un, bp, retry_check_flag,
 			    NULL, NULL, 0, un->un_busy_timeout,
 			    kstat_waitq_enter);
 			SD_TRACE(SD_LOG_IO_CORE | SD_LOG_ERROR, un,
@@ -16432,10 +16171,10 @@
 	SD_FILL_SCSI1_LUN(un, un->un_rqs_pktp);
 
 	/* Set up the other needed members in the ARQ scsi_pkt. */
-	un->un_rqs_pktp->pkt_comp   = sdintr;
-	un->un_rqs_pktp->pkt_time   = sd_io_time;
-	un->un_rqs_pktp->pkt_flags |=
-	    (FLAG_SENSING | FLAG_HEAD);	/* (1222170) */
+	un->un_rqs_pktp->pkt_comp = sdintr;
+	un->un_rqs_pktp->pkt_time = ((ISCD(un)) ? 2 : 1) *
+	    (ushort_t)un->un_io_time;
+	un->un_rqs_pktp->pkt_flags |= (FLAG_SENSING | FLAG_HEAD);
 
 	/*
 	 * Allocate  & init the sd_xbuf struct for the RQS command. Do not
@@ -16470,19 +16209,16 @@
 	 * The 3rd case is the HBA (adp) always return enabled on
 	 * scsi_ifgetgetcap even when it's not enable, the best approach
 	 * is issue a scsi_ifsetcap then a scsi_ifgetcap
-	 * Note: this case is to circumvent the Adaptec bug. (x86 only)
 	 */
 
 	if (un->un_f_is_fibre == TRUE) {
 		un->un_f_arq_enabled = TRUE;
 	} else {
-#if defined(__i386) || defined(__amd64)
 		/*
-		 * Circumvent the Adaptec bug, remove this code when
-		 * the bug is fixed
+		 * XXX Circumvent the Adaptec bug, remove this code when
+		 * the bug is fixed.
 		 */
 		(void) scsi_ifsetcap(SD_ADDRESS(un), "auto-rqsense", 1, 1);
-#endif
 		switch (scsi_ifgetcap(SD_ADDRESS(un), "auto-rqsense", 1)) {
 		case 0:
 			SD_INFO(SD_LOG_ATTACH_DETACH, un,
@@ -16777,7 +16513,48 @@
 	return (1);
 }
 
+static void
+sd_slow_io_ereport(struct scsi_pkt *pktp)
+{
+	struct buf *bp;
+	struct sd_lun *un;
+	char *devid;
 
+	ASSERT(pktp != NULL);
+	bp = (struct buf *)pktp->pkt_private;
+	ASSERT(bp != NULL);
+	un = SD_GET_UN(bp);
+	ASSERT(un != NULL);
+
+	SD_ERROR(SD_LOG_IO_CORE | SD_LOG_ERROR, un,
+	    "Slow IO detected SD: 0x%p delta in nsec: %llu",
+	    (void *)un, pktp->pkt_stop - pktp->pkt_start);
+
+	devid = DEVI(un->un_sd->sd_dev)->devi_devid_str;
+	scsi_fm_ereport_post(un->un_sd, 0, NULL, "cmd.disk.slow-io",
+	    fm_ena_generate(0, FM_ENA_FMT1), devid, NULL, DDI_NOSLEEP, NULL,
+	    FM_VERSION, DATA_TYPE_UINT8, FM_EREPORT_VERS0,
+	    "start", DATA_TYPE_UINT64, pktp->pkt_start,
+	    "stop", DATA_TYPE_UINT64, pktp->pkt_stop,
+	    "delta", DATA_TYPE_UINT64, pktp->pkt_stop - pktp->pkt_start,
+	    "threshold", DATA_TYPE_UINT64, un->un_slow_io_threshold,
+	    "pkt-reason", DATA_TYPE_UINT32, pktp->pkt_reason,
+	    NULL);
+}
+
+/* Clamp the value between 0..max using min as the offset */
+static int
+clamp_lat(int bucket, int min, int max)
+{
+
+	if (max < bucket)
+		bucket = max;
+	if (min > bucket)
+		bucket = min;
+
+	return (bucket - min);
+}
+
 /*
  *    Function: sdintr
  *
@@ -16795,6 +16572,8 @@
 	struct sd_lun	*un;
 	size_t		actual_len;
 	sd_ssc_t	*sscp;
+	hrtime_t	io_delta = 0LL;
+	int 		bucket;
 
 	ASSERT(pktp != NULL);
 	bp = (struct buf *)pktp->pkt_private;
@@ -16831,7 +16610,30 @@
 	un->un_in_callback++;
 
 	SD_UPDATE_KSTATS(un, kstat_runq_exit, bp);
+	/* If the HBA driver did not set the stop time, set it now. */
+	if (pktp->pkt_stop == 0)
+		pktp->pkt_stop = gethrtime();
+	/*
+	 * If there are HBA drivers or layered drivers which do not participate
+	 * in slow-io diagnosis, the start time, set above may be overwritten
+	 * with zero. If pkt_start is zero, the delta should also be zero.
+	 */
+	if (pktp->pkt_start != 0)
+		io_delta = pktp->pkt_stop - pktp->pkt_start;
+	if (un->un_slow_io_threshold > 0 && io_delta > un->un_slow_io_threshold)
+		sd_slow_io_ereport(pktp);
+	if (un->un_lat_stats) {
+		un->un_lat_stats->l_nrequest++;
+		un->un_lat_stats->l_sum += io_delta;
 
+		/* Track the latency in usec and quantize by power of 2 */
+		bucket = clamp_lat(ddi_fls(io_delta / 1000),
+		    SD_LAT_MIN_USEC_SHIFT, SD_LAT_MAX_USEC_SHIFT - 1);
+		ASSERT3S(bucket, >=, 0);
+		ASSERT3S(bucket, <, ARRAY_SIZE(un->un_lat_stats->l_histogram));
+		un->un_lat_stats->l_histogram[bucket]++;
+	}
+
 #ifdef	SDDEBUG
 	if (bp == un->un_retry_bp) {
 		SD_TRACE(SD_LOG_IO | SD_LOG_ERROR, un, "sdintr: "
@@ -16930,7 +16732,6 @@
 			goto exit;
 		}
 
-#if (defined(__i386) || defined(__amd64))	/* DMAFREE for x86 only */
 		/*
 		 * We want to either retry or fail this command, so free
 		 * the DMA resources here.  If we retry the command then
@@ -16946,7 +16747,6 @@
 			scsi_dmafree(pktp);
 			xp->xb_pkt_flags |= SD_XB_DMA_FREED;
 		}
-#endif
 
 		SD_TRACE(SD_LOG_IO_CORE | SD_LOG_ERROR, un,
 		    "sdintr: arq done, sd_handle_auto_request_sense\n");
@@ -17022,8 +16822,6 @@
 	}
 
 not_successful:
-
-#if (defined(__i386) || defined(__amd64))	/* DMAFREE for x86 only */
 	/*
 	 * The following is based upon knowledge of the underlying transport
 	 * and its use of DMA resources.  This code should be removed when
@@ -17051,7 +16849,6 @@
 		scsi_dmafree(pktp);
 		xp->xb_pkt_flags |= SD_XB_DMA_FREED;
 	}
-#endif
 
 	/*
 	 * The command did not successfully complete as requested so check
@@ -17069,7 +16866,8 @@
 		 */
 		if ((pktp->pkt_reason == CMD_CMPLT) &&
 		    (SD_GET_PKT_STATUS(pktp) == STATUS_CHECK)) {
-			sd_send_request_sense_command(un, bp, pktp);
+			sd_send_request_sense_command(un, bp,
+			    SD_RETRIES_STANDARD, pktp);
 		} else {
 			sd_return_failed_command(un, bp, EIO);
 		}
@@ -17713,21 +17511,9 @@
 	 * If the request sense failed (for whatever reason), attempt
 	 * to retry the original command.
 	 */
-#if defined(__i386) || defined(__amd64)
-	/*
-	 * SD_RETRY_DELAY is conditionally compile (#if fibre) in
-	 * sddef.h for Sparc platform, and x86 uses 1 binary
-	 * for both SCSI/FC.
-	 * The SD_RETRY_DELAY value need to be adjusted here
-	 * when SD_RETRY_DELAY change in sddef.h
-	 */
 	sd_retry_command(un, bp, SD_RETRIES_STANDARD,
 	    sd_print_sense_failed_msg, msgp, EIO,
 	    un->un_f_is_fibre?drv_usectohz(100000):(clock_t)0, NULL);
-#else
-	sd_retry_command(un, bp, SD_RETRIES_STANDARD,
-	    sd_print_sense_failed_msg, msgp, EIO, SD_RETRY_DELAY, NULL);
-#endif
 
 	return (SD_SENSE_DATA_IS_INVALID);
 }
@@ -19173,7 +18959,7 @@
 	funcp = ((pktp->pkt_statistics & STAT_PERR) == 0) ?
 	    sd_print_retry_msg : NULL;
 
-	sd_retry_command(un, bp, (SD_RETRIES_STANDARD | SD_RETRIES_ISOLATE),
+	sd_retry_command(un, bp, (SD_RETRIES_VICTIM | SD_RETRIES_ISOLATE),
 	    funcp, NULL, EIO, SD_RESTART_TIMEOUT, NULL);
 }
 
@@ -19276,22 +19062,14 @@
 	if (un->un_f_arq_enabled == FALSE) {
 		SD_INFO(SD_LOG_IO_CORE, un, "sd_pkt_status_check_condition: "
 		    "no ARQ, sending request sense command\n");
-		sd_send_request_sense_command(un, bp, pktp);
+		sd_send_request_sense_command(un, bp, SD_RETRIES_STANDARD,
+		    pktp);
 	} else {
 		SD_INFO(SD_LOG_IO_CORE, un, "sd_pkt_status_check_condition: "
 		    "ARQ,retrying request sense command\n");
-#if defined(__i386) || defined(__amd64)
-		/*
-		 * The SD_RETRY_DELAY value need to be adjusted here
-		 * when SD_RETRY_DELAY change in sddef.h
-		 */
 		sd_retry_command(un, bp, SD_RETRIES_STANDARD, NULL, NULL, EIO,
-		    un->un_f_is_fibre?drv_usectohz(100000):(clock_t)0,
+		    un->un_f_is_fibre ? drv_usectohz(100000) : (clock_t)0,
 		    NULL);
-#else
-		sd_retry_command(un, bp, SD_RETRIES_STANDARD, NULL, NULL,
-		    EIO, SD_RETRY_DELAY, NULL);
-#endif
 	}
 
 	SD_TRACE(SD_LOG_IO_CORE, un, "sd_pkt_status_check_condition: exit\n");
@@ -20047,7 +19825,7 @@
 	ucmd_buf.uscsi_rqbuf	= (caddr_t)&sense_buf;
 	ucmd_buf.uscsi_rqlen	= sizeof (sense_buf);
 	ucmd_buf.uscsi_flags	= USCSI_RQENABLE | USCSI_READ | USCSI_SILENT;
-	ucmd_buf.uscsi_timeout	= 60;
+	ucmd_buf.uscsi_timeout	= un->un_uscsi_timeout;
 
 	status = sd_ssc_send(ssc, &ucmd_buf, FKIOCTL,
 	    UIO_SYSSPACE, path_flag);
@@ -20263,7 +20041,7 @@
 	ucmd_buf.uscsi_rqbuf	= (caddr_t)&sense_buf;
 	ucmd_buf.uscsi_rqlen	= sizeof (sense_buf);
 	ucmd_buf.uscsi_flags	= USCSI_RQENABLE | USCSI_READ | USCSI_SILENT;
-	ucmd_buf.uscsi_timeout	= 60;
+	ucmd_buf.uscsi_timeout	= un->un_uscsi_timeout;
 
 	/*
 	 * Read Capacity (16) is a Service Action In command.  One
@@ -20307,11 +20085,21 @@
 		 *		(MSB in byte:8 & LSB in byte:11)
 		 *
 		 *  byte 13: LOGICAL BLOCKS PER PHYSICAL BLOCK EXPONENT
+		 *
+		 *  byte 14:
+		 *	bit 7: Thin-Provisioning Enabled
+		 *	bit 6: Thin-Provisioning Read Zeros
 		 */
 		capacity = BE_64(capacity16_buf[0]);
 		lbasize = BE_32(*(uint32_t *)&capacity16_buf[1]);
 		lbpb_exp = (BE_64(capacity16_buf[1]) >> 16) & 0x0f;
 
+		un->un_thin_flags = 0;
+		if (((uint8_t *)capacity16_buf)[14] & (1 << 7))
+			un->un_thin_flags |= SD_THIN_PROV_ENABLED;
+		if (((uint8_t *)capacity16_buf)[14] & (1 << 6))
+			un->un_thin_flags |= SD_THIN_PROV_READ_ZEROS;
+
 		pbsize = lbasize << lbpb_exp;
 
 		/*
@@ -20485,7 +20273,7 @@
 	ucmd_buf.uscsi_rqbuf	= (caddr_t)&sense_buf;
 	ucmd_buf.uscsi_rqlen	= sizeof (struct scsi_extended_sense);
 	ucmd_buf.uscsi_flags	= USCSI_RQENABLE | USCSI_SILENT;
-	ucmd_buf.uscsi_timeout	= 200;
+	ucmd_buf.uscsi_timeout	= 3 * un->un_uscsi_timeout;
 
 	status = sd_ssc_send(ssc, &ucmd_buf, FKIOCTL,
 	    UIO_SYSSPACE, path_flag);
@@ -20704,7 +20492,7 @@
 	ucmd_buf.uscsi_rqbuf	= NULL;
 	ucmd_buf.uscsi_rqlen	= 0;
 	ucmd_buf.uscsi_flags	= USCSI_READ | USCSI_SILENT;
-	ucmd_buf.uscsi_timeout	= 200;	/* Excessive legacy value */
+	ucmd_buf.uscsi_timeout	= 2 * un->un_uscsi_timeout;
 
 	status = sd_ssc_send(ssc, &ucmd_buf, FKIOCTL,
 	    UIO_SYSSPACE, SD_PATH_DIRECT);
@@ -20807,7 +20595,7 @@
 	if ((flag & SD_DONT_RETRY_TUR) != 0) {
 		ucmd_buf.uscsi_flags |= USCSI_DIAGNOSE;
 	}
-	ucmd_buf.uscsi_timeout	= 60;
+	ucmd_buf.uscsi_timeout	= un->un_uscsi_timeout;
 
 	status = sd_ssc_send(ssc, &ucmd_buf, FKIOCTL,
 	    UIO_SYSSPACE, ((flag & SD_BYPASS_PM) ? SD_PATH_DIRECT :
@@ -20904,7 +20692,7 @@
 	ucmd_buf.uscsi_rqbuf	= (caddr_t)&sense_buf;
 	ucmd_buf.uscsi_rqlen	= sizeof (struct scsi_extended_sense);
 	ucmd_buf.uscsi_flags	= USCSI_RQENABLE | USCSI_READ | USCSI_SILENT;
-	ucmd_buf.uscsi_timeout	= 60;
+	ucmd_buf.uscsi_timeout	= un->un_uscsi_timeout;
 
 	status = sd_ssc_send(ssc, &ucmd_buf, FKIOCTL,
 	    UIO_SYSSPACE, SD_PATH_STANDARD);
@@ -21010,7 +20798,7 @@
 	ucmd_buf.uscsi_rqbuf	= (caddr_t)&sense_buf;
 	ucmd_buf.uscsi_rqlen	= sizeof (struct scsi_extended_sense);
 	ucmd_buf.uscsi_flags	= USCSI_RQENABLE | USCSI_WRITE | USCSI_SILENT;
-	ucmd_buf.uscsi_timeout	= 60;
+	ucmd_buf.uscsi_timeout	= un->un_uscsi_timeout;
 
 	switch (usr_cmd) {
 	case SD_SCSI3_REGISTER: {
@@ -21205,7 +20993,7 @@
 	uscmd->uscsi_rqlen = SENSE_LENGTH;
 	uscmd->uscsi_rqresid = SENSE_LENGTH;
 	uscmd->uscsi_flags = USCSI_RQENABLE | USCSI_SILENT;
-	uscmd->uscsi_timeout = sd_io_time;
+	uscmd->uscsi_timeout = un->un_cmd_timeout;
 
 	/*
 	 * Allocate an sd_uscsi_info struct and fill it with the info
@@ -21352,9 +21140,8 @@
 	}
 
 done:
-	if (uip->ui_dkc.dkc_callback != NULL) {
+	if (uip->ui_dkc.dkc_callback != NULL)
 		(*uip->ui_dkc.dkc_callback)(uip->ui_dkc.dkc_cookie, status);
-	}
 
 	ASSERT((bp->b_flags & B_REMAPPED) == 0);
 	freerbuf(bp);
@@ -21366,8 +21153,226 @@
 	return (status);
 }
 
+/*
+ * Issues a single SCSI UNMAP command with a prepared UNMAP parameter list.
+ * Returns zero on success, or the non-zero command error code on failure.
+ */
+static int
+sd_send_scsi_UNMAP_issue_one(sd_ssc_t *ssc, unmap_param_hdr_t *uph,
+    uint64_t num_descr, uint64_t bytes)
+{
+	struct sd_lun		*un = ssc->ssc_un;
+	struct scsi_extended_sense	sense_buf;
+	union scsi_cdb		cdb;
+	struct uscsi_cmd	ucmd_buf;
+	int			status;
+	const uint64_t		param_size = sizeof (unmap_param_hdr_t) +
+	    num_descr * sizeof (unmap_blk_descr_t);
 
+	uph->uph_data_len = BE_16(param_size - 2);
+	uph->uph_descr_data_len = BE_16(param_size - 8);
+
+	bzero(&cdb, sizeof (cdb));
+	bzero(&ucmd_buf, sizeof (ucmd_buf));
+	bzero(&sense_buf, sizeof (struct scsi_extended_sense));
+
+	cdb.scc_cmd = SCMD_UNMAP;
+	FORMG1COUNT(&cdb, param_size);
+
+	ucmd_buf.uscsi_cdb	= (char *)&cdb;
+	ucmd_buf.uscsi_cdblen	= (uchar_t)CDB_GROUP1;
+	ucmd_buf.uscsi_bufaddr	= (caddr_t)uph;
+	ucmd_buf.uscsi_buflen	= param_size;
+	ucmd_buf.uscsi_rqbuf	= (caddr_t)&sense_buf;
+	ucmd_buf.uscsi_rqlen	= sizeof (struct scsi_extended_sense);
+	ucmd_buf.uscsi_flags	= USCSI_WRITE | USCSI_RQENABLE | USCSI_SILENT;
+	ucmd_buf.uscsi_timeout	= un->un_cmd_timeout;
+
+	status = sd_ssc_send(ssc, &ucmd_buf, FKIOCTL, UIO_SYSSPACE,
+	    SD_PATH_STANDARD);
+
+	switch (status) {
+	case 0:
+		sd_ssc_assessment(ssc, SD_FMT_STANDARD);
+
+		if (un->un_unmapstats) {
+			atomic_inc_64(&un->un_unmapstats->us_cmds.value.ui64);
+			atomic_add_64(&un->un_unmapstats->us_extents.value.ui64,
+			    num_descr);
+			atomic_add_64(&un->un_unmapstats->us_bytes.value.ui64,
+			    bytes);
+		}
+		break;	/* Success! */
+	case EIO:
+		if (un->un_unmapstats)
+			atomic_inc_64(&un->un_unmapstats->us_errs.value.ui64);
+		switch (ucmd_buf.uscsi_status) {
+		case STATUS_RESERVATION_CONFLICT:
+			status = EACCES;
+			break;
+		default:
+			break;
+		}
+		break;
+	default:
+		if (un->un_unmapstats)
+			atomic_inc_64(&un->un_unmapstats->us_errs.value.ui64);
+		break;
+	}
+
+	return (status);
+}
+
 /*
+ * Returns a pointer to the i'th block descriptor inside an UNMAP param list.
+ */
+static inline unmap_blk_descr_t *
+UNMAP_blk_descr_i(void *buf, uint64_t i)
+{
+	return ((unmap_blk_descr_t *)((uint8_t *)buf +
+	    sizeof (unmap_param_hdr_t) + (i * sizeof (unmap_blk_descr_t))));
+}
+
+/*
+ * Takes the list of extents from sd_send_scsi_UNMAP, chops it up, prepares
+ * UNMAP block descriptors and issues individual SCSI UNMAP commands. While
+ * doing so we consult the block limits to determine at most how many
+ * extents and LBAs we can UNMAP in one command.
+ * If a command fails for whatever, reason, extent list processing is aborted
+ * and the failed command's status is returned. Otherwise returns 0 on
+ * success.
+ */
+static int
+sd_send_scsi_UNMAP_issue(dev_t dev, sd_ssc_t *ssc, const dkioc_free_list_t *dfl)
+{
+	struct sd_lun		*un = ssc->ssc_un;
+	unmap_param_hdr_t	*uph;
+	sd_blk_limits_t		*lim = &un->un_blk_lim;
+	int			rval = 0;
+	int			partition;
+	/* partition offset & length in system blocks */
+	diskaddr_t		part_off_sysblks = 0, part_len_sysblks = 0;
+	uint64_t		part_off, part_len;
+	uint64_t		descr_cnt_lim, byte_cnt_lim;
+	uint64_t		descr_issued = 0, bytes_issued = 0;
+
+	uph = kmem_zalloc(SD_UNMAP_PARAM_LIST_MAXSZ, KM_SLEEP);
+
+	partition = SDPART(dev);
+	(void) cmlb_partinfo(un->un_cmlbhandle, partition, &part_len_sysblks,
+	    &part_off_sysblks, NULL, NULL, (void *)SD_PATH_DIRECT);
+	part_off = SD_SYSBLOCKS2BYTES(part_off_sysblks);
+	part_len = SD_SYSBLOCKS2BYTES(part_len_sysblks);
+
+	ASSERT(un->un_blk_lim.lim_max_unmap_lba_cnt != 0);
+	ASSERT(un->un_blk_lim.lim_max_unmap_descr_cnt != 0);
+	/* Spec says 0xffffffff are special values, so compute maximums. */
+	byte_cnt_lim = lim->lim_max_unmap_lba_cnt < UINT32_MAX ?
+	    (uint64_t)lim->lim_max_unmap_lba_cnt * un->un_tgt_blocksize :
+	    UINT64_MAX;
+	descr_cnt_lim = MIN(lim->lim_max_unmap_descr_cnt, SD_UNMAP_MAX_DESCR);
+
+	for (size_t i = 0; i < dfl->dfl_num_exts; i++) {
+		const dkioc_free_list_ext_t *ext = &dfl->dfl_exts[i];
+		uint64_t ext_start = ext->dfle_start;
+		uint64_t ext_length = ext->dfle_length;
+
+		while (ext_length > 0) {
+			unmap_blk_descr_t *ubd;
+			/* Respect device limit on LBA count per command */
+			uint64_t len = MIN(MIN(ext_length, byte_cnt_lim -
+			    bytes_issued), SD_TGTBLOCKS2BYTES(un, UINT32_MAX));
+
+			/* check partition limits */
+			if (ext_start + len > part_len) {
+				rval = SET_ERROR(EINVAL);
+				goto out;
+			}
+#ifdef	DEBUG
+			if (dfl->dfl_ck_func)
+				dfl->dfl_ck_func(dfl->dfl_offset + ext_start,
+				    len, dfl->dfl_ck_arg);
+#endif
+			ASSERT3U(descr_issued, <, descr_cnt_lim);
+			ASSERT3U(bytes_issued, <, byte_cnt_lim);
+			ubd = UNMAP_blk_descr_i(uph, descr_issued);
+
+			/* adjust in-partition addresses to be device-global */
+			ubd->ubd_lba = BE_64(SD_BYTES2TGTBLOCKS(un,
+			    dfl->dfl_offset + ext_start + part_off));
+			ubd->ubd_lba_cnt = BE_32(SD_BYTES2TGTBLOCKS(un, len));
+
+			descr_issued++;
+			bytes_issued += len;
+
+			/* Issue command when device limits reached */
+			if (descr_issued == descr_cnt_lim ||
+			    bytes_issued == byte_cnt_lim) {
+				rval = sd_send_scsi_UNMAP_issue_one(ssc, uph,
+				    descr_issued, bytes_issued);
+				if (rval != 0)
+					goto out;
+				descr_issued = 0;
+				bytes_issued = 0;
+			}
+
+			ext_start += len;
+			ext_length -= len;
+		}
+	}
+
+	if (descr_issued > 0) {
+		/* issue last command */
+		rval = sd_send_scsi_UNMAP_issue_one(ssc, uph, descr_issued,
+		    bytes_issued);
+	}
+
+out:
+	kmem_free(uph, SD_UNMAP_PARAM_LIST_MAXSZ);
+	return (rval);
+}
+
+/*
+ * Issues one or several UNMAP commands based on a list of extents to be
+ * unmapped. The internal multi-command processing is hidden, as the exact
+ * number of commands and extents per command is limited by both SCSI
+ * command syntax and device limits (as expressed in the SCSI Block Limits
+ * VPD page and un_blk_lim in struct sd_lun).
+ * Returns zero on success, or the error code of the first failed SCSI UNMAP
+ * command.
+ */
+static int
+sd_send_scsi_UNMAP(dev_t dev, sd_ssc_t *ssc, dkioc_free_list_t *dfl, int flag)
+{
+	struct sd_lun		*un = ssc->ssc_un;
+	int			rval = 0;
+
+	ASSERT(!mutex_owned(SD_MUTEX(un)));
+	ASSERT(dfl != NULL);
+
+	/* Per spec, any of these conditions signals lack of UNMAP support. */
+	if (!(un->un_thin_flags & SD_THIN_PROV_ENABLED) ||
+	    un->un_blk_lim.lim_max_unmap_descr_cnt == 0 ||
+	    un->un_blk_lim.lim_max_unmap_lba_cnt == 0) {
+		return (SET_ERROR(ENOTSUP));
+	}
+
+	/* For userspace calls we must copy in. */
+	if (!(flag & FKIOCTL) && (dfl = dfl_copyin(dfl, flag, KM_SLEEP)) ==
+	    NULL)
+		return (SET_ERROR(EFAULT));
+
+	rval = sd_send_scsi_UNMAP_issue(dev, ssc, dfl);
+
+	if (!(flag & FKIOCTL)) {
+		dfl_free(dfl);
+		dfl = NULL;
+	}
+
+	return (rval);
+}
+
+/*
  *    Function: sd_send_scsi_GET_CONFIGURATION
  *
  * Description: Issues the get configuration command to the device.
@@ -21423,7 +21428,7 @@
 	ucmdbuf->uscsi_cdblen = CDB_GROUP1;
 	ucmdbuf->uscsi_bufaddr = (caddr_t)bufaddr;
 	ucmdbuf->uscsi_buflen = buflen;
-	ucmdbuf->uscsi_timeout = sd_io_time;
+	ucmdbuf->uscsi_timeout = un->un_uscsi_timeout;
 	ucmdbuf->uscsi_rqbuf = (caddr_t)rqbuf;
 	ucmdbuf->uscsi_rqlen = rqbuflen;
 	ucmdbuf->uscsi_flags = USCSI_RQENABLE|USCSI_SILENT|USCSI_READ;
@@ -21516,7 +21521,7 @@
 	ucmdbuf->uscsi_cdblen = CDB_GROUP1;
 	ucmdbuf->uscsi_bufaddr = (caddr_t)bufaddr;
 	ucmdbuf->uscsi_buflen = buflen;
-	ucmdbuf->uscsi_timeout = sd_io_time;
+	ucmdbuf->uscsi_timeout = un->un_uscsi_timeout;
 	ucmdbuf->uscsi_rqbuf = (caddr_t)rqbuf;
 	ucmdbuf->uscsi_rqlen = rqbuflen;
 	ucmdbuf->uscsi_flags = USCSI_RQENABLE|USCSI_SILENT|USCSI_READ;
@@ -21629,7 +21634,7 @@
 	ucmd_buf.uscsi_rqbuf	= (caddr_t)&sense_buf;
 	ucmd_buf.uscsi_rqlen	= sizeof (struct scsi_extended_sense);
 	ucmd_buf.uscsi_flags	= USCSI_RQENABLE | USCSI_READ | USCSI_SILENT;
-	ucmd_buf.uscsi_timeout	= 60;
+	ucmd_buf.uscsi_timeout	= un->un_uscsi_timeout;
 
 	status = sd_ssc_send(ssc, &ucmd_buf, FKIOCTL,
 	    UIO_SYSSPACE, path_flag);
